#include "ad_deriv.h"

void  ad_func(DERIV_TYPE [], DERIV_TYPE [], DERIV_TYPE);

int  main() {
  DERIV_TYPE x[3], y[3], z;
  double v[6][3];
  double gv[3], hv[6][3];
  int i, j;

  /* Set values for independent variables */
  DERIV_val(x[0]) = ...;
    :
    
  /* Set values of v */
  for (i=0; i<6; i++)
    for (j=0; j<3; j++)
      v[i][j] = ...;

  /* Initialize the derivatives of the independent variables */
  ad_AD_InitHV(6, 3); 
  ad_AD_SetIndepArrayHV(x, 3, v);
  ad_AD_SetIndepArrayHV(y, 3, v);
  ad_AD_SetIndepDone();

  /* Compute the derivatives */
  ad_func(x, y, z);

  /* Extract derivative values */
  ad_AD_ExtractGradV(z, gv);
  ad_AD_ExtractHV(z, hv);

}
